;;;;	Project: CC
;;;;
;;;;	Module: bbs.sh
;;;;
;;;;	Author: Jeff Stephenson

(enum
	BBS_POST
	BBS_READ
	BBS_READ_NEXT
	BBS_READ_PREV
	BBS_READ_FIRST
	BBS_READ_LAST
	BBS_ERASE
	BBS_READ_NEW
	BBS_QUERY
	BBS_POST_SID
	BBS_POST_FORWARD

	BBS_SCAN
	BBS_ERASE_TO

	BBS_QUERY_ALL
	BBS_LIST
	BBS_RELIST
)


(enum
	SYSOP_BBS
	GENERAL_BBS
	BUG_BBS
	INFO_BBS
	OPINIONS_BBS
	PERSONALS_BBS
	SYSTEM_BBS
)

(define	BBS_NAK_PRVLG_RD	$0001)
(define	BBS_NAK_PRVLG_WR	$0002)
(define	BBS_NAK_PRVLG_DL	$0003)
(define	BBS_NAK_FULL		$0004)
(define	BBS_NAK_NONE		$0005)
(define	BBS_NAK_NO_BBS		$0006)

(define	BBS_SCAN_FORWARD	%00000001)
(define	BBS_SCAN_ALL		%00000010)

(define	BBS_PRVLG_READ		$0001)
(define	BBS_PRVLG_WRITE	$0002)

(define	BBS_NAME_DELIMITER $1b)

; Host defined message state bits
(define	NO_PREV			$8000)
(define	NO_NEXT			$4000)
(define	NO_MSG			$2000)
(define	NO_ERASE			$1000)

(define	NO_MORE_MSGS	(| NO_NEXT NO_PREV))
(define	FLAG_MASK		(| NO_PREV NO_NEXT NO_MSG NO_ERASE))
(define	NUM_MASK			(~ FLAG_MASK))

;; BBS purposes
(define	BBS_TYPE_ALL			-1)
(define	BBS_TYPE_BBS			`B)
(define	BBS_TYPE_SHOPPING		`S)
(define	BBS_TYPE_CONFERENCE	`C)
(define	BBS_TYPE_COMPLAINT	`c)
(define	BBS_TYPE_NOTELOGS		42)
(define	BBS_TYPE_VERACITY		`V)
(define	BBS_TYPE_LARRYLIBS	`L)
(define	BBS_TYPE_BARON_SCORE	10)
(define	BBS_TYPE_GOLF_SCORE	11)
(define	BBS_TYPE_PAINTBALL_SCORE	12)


(define COMPLAINT_BBS_NUM		0)
(define CONF_TOPIC_BBS_NUM		0)
