(module# MSGQUEUE)

(class msgQueue of List
	(properties
		int lastMsg: 0
	)
	(methods
		getMsg
		putMsg
	)
	;***
	;*** Make a copy of the message and put it in queue.
	;***
	(method (putMsg msg &tmp newData newMsg len)   
		(= len (KArray ArraySize (msg data?)))
		(= newData (KArray ArrayNew len BYTEARRAY))
		(KArray ArrayCopy newData 0 (DataBlk (msg data?)) 0 -1)

		(= newMsg (Send new: newData len))
		(newMsg 
			command: (msg command?),
			msgType: (msg msgType?),
			from:		(msg from?),
			fromSID:	(msg fromSID?),
			to:		(msg to?),
			toSID: 	(msg toSID?),
			sid: 		(msg sid?),			;; copying this for numbering
		)
		(self add: newMsg)
	)

	;***
	;*** Dispose of last message and then get oldest message
	;***
	(method (getMsg &tmp curMsg) 
		(if lastMsg
			(lastMsg dispose:)
			(= lastMsg 0)
		)
		(= curMsg 0)
		(if (self size:)
			(= curMsg (self at: 0))
			(= lastMsg curMsg)
			(self delete: curMsg)
		)
		(return curMsg)
	)
)

