;;;;
;;;;	NETUSER.SC
;;;;	(c) Sierra On-Line, Inc, 1988
;;;;
;;;;	Author: Jeff Stephenson
;;;;
;;;;	A network version of User.
;;;;
;;;;	Classes:
;;;;		NetUser



(module# NETUSER)


(define	INPUTLEN		210)

(class NetUser of User
	(properties
		id    name: 	"NetUser"
		int	sid	   0
		int   numLines 2	;; number of lines for getText.
		int   disposeOfIncomingMessage TRUE
	)


	(method (init)
		(super init: (String new: INPUTLEN))
		(= prompt (super prompt?))
	)


	(method (getText nLines &tmp rect retVal saveFont)
		(= saveFont (DEdit font?))
		(DEdit font: smallFont)

		(= rect (Rectangle new:))
		(TextSize rect "M" smallFont)
		(rect
			height:	(* (if argc nLines else numLines) (rect height:)),
			width:	256, 
		)

		(= retVal
			(Print
				prompt
				#p_at:		x y
				#p_width:	(rect width:)
				#p_rEdit:	inputLine (inputLine strMax:) rect
				&rest
			)
		)

		(rect dispose:)
		(DEdit font: saveFont)

		(return retVal)
	)


	(method (handleEvent event &tmp msg)
		(switch (event type?)
			(remoteEvt
				(if haveConnection
					(= msg (Msg with: (event message?) (event modifiers?)))
					(if (== msg NULLID)
						(return)
					)
					(if (& debugMsgs SHOW_MSG)
						(Debug DInspect msg)
					)
					(cond
						((IsObject (msg to?))
							(if netMsgProcessor
								(switch (msg command?)
									(SN_SEND
										(if ((netMsgProcessor nmpGameQueue?) size:)
											(if (== (msg msgType?) 1)
												(netMsgProcessor putMsg: (netMsgProcessor nmpChatQueue?) msg)
											else
												(netMsgProcessor putMsg: (netMsgProcessor nmpGameQueue?) msg)
											)

											(return)
										else	
											((msg to?) handleMsg: msg)
										)
									)
									(else
										(if ((netMsgProcessor nmpGameQueue?) size:)
											(netMsgProcessor putMsg: (netMsgProcessor nmpGameQueue?) msg)
											(return)
										else
											((msg to?) handleMsg: msg)
										)
									)
								)
							else
								((msg to?) handleMsg: msg)
							)
						)

						((== (& debugMsgs RCV_NOT_OBJ) 0)
						)
						(
							(Print
					 			"Message receiver not an object."
						 		#p_button	" Debug "	1
						 		#p_button	" Ignore "	0
						 	)
							(SetDebug msg)
						)
					)

					(if disposeOfIncomingMessage
						(msg dispose:)
					)
				)
			)
			(else
				(super handleEvent: event)
			)
		)
	)
	
	
	(method (said event)
		(or
			(cast handleEvent: event)
			(features handleEvent: event)
			(theGame handleEvent: event)
		)
	)


	(method (parse line evt)
		(evt message: line)
		(return TRUE)
	)
)

