;;;;	
;;;;	TSN.SH -- intermodule communications definitions for Sierra Network
;;;;
;;;;	Author: Jeff Stephenson


(enum 59950
	HOST
	MSG
	NETUSER
	PLAYER
	GROUP
	PACKDATA
	MSGQUEUE
	MSGPROC
)


;;; Communication commands.
(enum
	SN_ACK			;; 0
	SN_NAK
	SN_SEND
	SN_RSEND
	SN_LOCK
	SN_LOCKQUEUE
	SN_UNLOCK
	SN_OBJNEW
	SN_OBJID
	SN_OBJFREE

	SN_GRPJOIN		;; 10
	SN_GRPDEL
	SN_GRPMEM
	SN_SETINT
	SN_SETSTR
	SN_SETBYTEARRAY
	SN_SETINTARRAY
	SN_GETPROP
	SN_GETOBJ
	SN_ADD

	SN_SETEQ			;; 20
	SN_SETNE
	SN_LOGIN			;; this is what always comes back from other SN_LOGINs
	SN_GAMERIGHTS
	SN_GAMEKILL
	SN_RMI
	SN_SETUSERSID
	SN_BBS
	SN_SENDMANY
	SN_GAMEVERSION

	SN_REGISTER		;; 30
	SN_GRPPROP
	SN_EGETPROP
	SN_SET
	SN_ACCOUNTING
	SN_XFER
	SN_HOSTINFO
	SN_EMAIL
	SN_HINT
	SN_HOSTFILE
	
	SN_USERINFO		;; 40
	SN_OBJEXISTS
	SERV_LOGIN 		;; Server commands
	SERV_LOGOUT		;;
	SN_PASSWORD
	US_REQUEST
	SN_LOGIN_PRE_RELEASE ;; This is for PRE-release version software
	SN_WAITGRPREQUEST
	SN_UNSOLICITED
	SN_USERFIND

	SN_MUTEUNMUTE
	SN_OBJNEWLIST
	SN_OBJFREELIST
	SN_LOGINPWVER	;; 53 This is for RELEASE version software

	146
	SN_SYSOP_LOGIN
	SN_SYSOP_CMD
	SN_DEBUG
)


(define	NEW_OBJECT		1)
(define	NEW_GROUP		2)
(define	FIXED_OBJECT	3)
(define	FIXED_GROUP		4)
(define	NEW_LAND			5)

(define	PERMANENT		$80)

(define	ID_UNIQUE		-1)
(define	ID_SHARED		-2)


;;; Communications errors
(enum
	ERR_NONE
	ERR_CONNECT_LOST
	ERR_NAK_EXCEEDED
	ERR_NAK_TIMEOUT
	ERR_PACKET_SIZE_EXCEEDED
	ERR_NO_DSR
	ERR_STUCK_CD
	ERR_MODEM_RESPONSE
	ERR_LINE_BUSY
	ERR_NO_ANSWER
	ERR_NO_CARRIER
	ERR_NO_PACKETS
	ERR_NO_TELENET_PROMPT
	ERR_NO_TELENET_CONNECT
	ERR_NO_CONNECTION
	ERR_NAME_SHORT
	ERR_NAME_LONG
	ERR_NO_STATION
	ERR_STATION_NO_RESPONSE
	ERR_IPX_SETUP
	ERR_RECONNECT_UNSUPPORTED
	ERR_NO_RECONNECT_PROMPT
	ERR_TELENET_FALLBACK
	ERR_KB_BREAKOUT
)


;;; Debug stuff for communications.

(define	RCV_NOT_OBJ		%00000001)
(define	SHOW_MSG			%00000010)
(define	BRK_ON_MSG		%00000100)


;;; Notification defines.
(enum
	NOTIFY_NOBODY
	NOTIFY_MYSELF
	NOTIFY_CLONES
	NOTIFY_ONLYCLONES
	NOTIFY_CURGROUP
	NOTIFY_GROUP
)


;;; Host info defines
(enum
	HOST_NAME
	HOST_ADDRESSES
	HOST_TIME
	HOST_STATS
	HOST_WAITROOMS
	HOST_NUMBER
	HOST_WAITROOMS_NEW
)

(define	OLD_US_EMAILREQUEST	0)
(define	US_EMAILREQUEST		1)

(define	MYPASSWORD     	1)
(define	CHANGEPASSWORD		2)

(enum 1
	YOUR_BOX_IS
	HOST_CHOKED
	DATABASE_CHOKED
	DATABASE_BUSY
	DATABASE_DEAD
	UID_SERVER_DEAD
)

;;; LOGIN NAK SUBCMDS
(enum
	LOGIN_BAD_ID		
	LOGIN_NO_FREE		
	LOGIN_MULTIPLE		
	LOGIN_NOT_ALLOWED	
	LOGIN_HOST_BUSY	
	LOGIN_OCCUPIED		
	LOGIN_NOT_FLAT  
	LOGIN_NOT_PRIME
	LOGIN_BAD_TSN
	PASSWORD_FAIL_WRONG    
	
	PASSWORD_FAIL_STRUCTURE
	PASSWORD_OUT_OF_DATE
	USER_LOCKOUT           
	OK_GO_PLAY
	LOGIN_FAIL_OUT_OF_CREDITS
	BILLING_PROBLEMS
	PASSWORD_NOT_CHANGED
	LOGIN_VER_TOO_HIGH
	LOGIN_VER_TOO_LOW
	LOGIN_VER_LOCKOUT

	LOGIN_BAD_GAMENUM
)

;; Accounting messages
(enum
	ACCOUNT_READ_LOG
	ACCOUNT_DEL_LOG
	ACCOUNT_DEL_LOG1
	ACCOUNT_REN_LOG
	ACCOUNT_SEND_STATUS
	ACCOUNT_GET_STATUS
	ACCOUNT_SEND_STATUS_ADMIN   			; 6 used by admin program only
	ACCOUNT_SEND_ACCOUNT_STATUS_ADMIN   ; 7 used by admin program only
	ACCOUNT_ACKNOWLEDGE_STATUS
)

;; NAK subCmds on GRPJOIN
(enum 1
   GRPJOIN_NAK_INVALID_GROUP
   GRPJOIN_NAK_FULL
   GRPJOIN_NAK_INVALID_OBJECT
   GRPJOIN_NAK_LOCKED
   GRPJOIN_NAK_NO_LAND_RIGHTS
   GRPJOIN_NAK_VERSION
)

;; subCmds for UserInfo
(enum 1
	UI_RECV_MSG
	UI_PUT
	UI_GET
	UI_SET_USERNAME
)

