;;;;
;;;;	NETUSER.SC
;;;;	(c) Sierra On-Line, Inc, 1988
;;;;
;;;;	Author: Jeff Stephenson
;;;;
;;;;	A network version of User.
;;;;
;;;;	Classes:
;;;;		NetUser



(module# NETUSER)


(define	INPUTLEN		210)

(class NetUser of User
	(properties
		id    name: 	"NetUser"
		int	sid	   0
		int   numLines 2	;; number of lines for getText.
		int   disposeOfIncomingMessage TRUE
	)


	(method (init)
		(super init: (String new: INPUTLEN))
		(= prompt (super prompt?))
	)


	(method (getText nLines &tmp rect retVal saveFont)
		(= saveFont (DEdit font?))
		(DEdit font: smallFont)

		(= rect (Rectangle new:))
		(TextSize rect "M" smallFont)
		(rect
			height:	(* (if argc nLines else numLines) (rect height:)),
			width:	256, 
		)

		(= retVal
			(Print
				prompt
				#p_at:		x y
				#p_width:	(rect width:)
				#p_rEdit:	inputLine (inputLine strMax:) rect
				&rest
			)
		)

		(rect dispose:)
		(DEdit font: saveFont)

		(return retVal)
	)


	(method (handleEvent event &tmp msg)
		(switch (event type?)
			(remoteEvt
				(if haveConnection
					(= msg (Msg with: (event message?) (event modifiers?)))
					(if (== msg NULLID)
						(return)
					)
					(if (& debugMsgs SHOW_MSG)
						(Debug DInspect msg)
					)
					(cond
						((IsObject (msg to?))
							(if netMsgProcessor
								;; if there are already any messages in the nmpSystemQueue
								;; then do not allow any incoming messages to be 
								;; handled.
								(if ((netMsgProcessor nmpSystemQueue?) size:)
									(netMsgProcessor putMsg: msg)
									(return)
								else	
									((msg to?) handleMsg: msg)
								)
							else
								((msg to?) handleMsg: msg)
							)
						)

						;; big time kludge for OLS
						;;
						((== (msg to?) 0)
							(if curRoom
								(if (== (curRoom number?) 14) ;; ONLINESIGNUP
									(curRoom handleMsg: msg)
								)
							)
						)

						((== (& debugMsgs RCV_NOT_OBJ) 0)
						)

;RWL						(
;RWL							(Print
;RWL					 			"Message receiver not an object."
;RWL						 		#p_button	" Debug "	1
;RWL						 		#p_button	" Ignore "	0
;RWL						 	)
;RWL						)
					)

					(if disposeOfIncomingMessage
						(msg dispose:)
					)
				)
			)
			(else
				(super handleEvent: event)
			)
		)
	)
	
	
	(method (said event)
		(or
			(cast handleEvent: event)
			(features handleEvent: event)
			(theGame handleEvent: event)
		)
	)


	(method (parse line evt)
		(evt message: line)
		(return TRUE)
	)
)

